<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <!-- <el-form-item label="年份" prop="year">
        <el-select
          v-model="queryParams.year"
          placeholder="请选择年份"
          clearable
        >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="月份" prop="month">
        <el-select
          v-model="queryParams.month"
          placeholder="请选择月份"
          clearable
        >
          <el-option label="01" value="01"></el-option>
          <el-option label="02" value="02"></el-option>
          <el-option label="03" value="03"></el-option>
          <el-option label="04" value="04"></el-option>
          <el-option label="05" value="05"></el-option>
          <el-option label="06" value="06"></el-option>
          <el-option label="07" value="07"></el-option>
          <el-option label="08" value="08"></el-option>
          <el-option label="09" value="09"></el-option>
          <el-option label="10" value="10"></el-option>
          <el-option label="11" value="11"></el-option>
          <el-option label="12" value="12"></el-option>
        </el-select>
      </el-form-item> -->
      <el-form-item label="对比周期" label-width="120px">
        <el-date-picker
          v-model="appDate1"
          type="monthrange"
          @input="appDateInput1"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          format="yyyy-MM"
          value-format="yyyy-MM"
        />
        和
        <el-date-picker
          v-model="appDate2"
          type="monthrange"
          @input="appDateInput2"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          format="yyyy-MM"
          value-format="yyyy-MM"
        />
      </el-form-item>


      <el-form-item label="地区级别" prop="province" label-width="118px">
        <el-select
          v-model="queryParams.province"
          placeholder="请选择省份"
        >
          <el-option label="云南省" value="53"></el-option>
        </el-select>

        <el-select
          v-model="queryParams.appliCity"
          placeholder="请选择州市"
          @change="search"
        >
          <el-option label="不选择" value="null"></el-option>
          <el-option label="全部州市" value="all"></el-option>
          <el-option
            v-for="region in regionOptions"
            :key="region.cityShortName"
            :label="region.cityShortName"
            :value="region.code"
            :disabled="region.cityShortName == '云南省'"
          />
        </el-select>
        <el-select
          v-model="queryParams.appliCounty"
          placeholder="请选择区县"
          :disabled="opensb"
        >
          <el-option label="不选择" value="null"></el-option>
          <el-option label="全部区县" value="all"></el-option>
          <!--
          <el-option
            v-for="item in ysDistrictCounty"
            :key="item.cityShortName"
            :label="item.cityShortName"
            :value="item.name"
          />-->
        </el-select>
      </el-form-item>




      <el-form-item style="margin-left: 25px;">
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
        <el-button type="primary"  size="mini" @click="handleExport"
          >导出列表</el-button
        >
      </el-form-item>
    </el-form>

    <div id="scrollTable">
      <el-table
        v-loading="loading"
        :data="Population"
        :max-height="maxHeight"
        :header-cell-style="{ background: '#2a8eed', color: '#fafcfe' }"
      >
        <el-table-column label="对比地区" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{ scope.row["areaName"] }}</span>
          </template>
        </el-table-column>
        <el-table-column label="对比数据" align="center" width="100" fixed="left">


          <el-table-column label="对比周期" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{ scope.row["compareRate"] }}</span>
          </template>
        </el-table-column>
        </el-table-column>
        <el-table-column label="申请" align="center" prop="createBy" >
          <template slot-scope="scope">
            <span>{{ scope.row["aplTotalCnt"] }}</span>
          </template>

        </el-table-column>
        <el-table-column label="注册" align="center" prop="createBy" >
          <template slot-scope="scope">
            <span>{{ scope.row["regTotalCnt"] }}</span>
          </template>

        </el-table-column>
        <el-table-column label="有效" align="center" prop="createBy" >
          <template slot-scope="scope">
            <span>{{ scope.row["actTotalCnt"] }}</span>
          </template>

        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
  import {listReportGrowth} from '@/api/trademark/chineseTrademarkApplication'
  import {getRegionList} from "@/api/system/urPatentValid";
export default {
  name: "Chinesetrademarks",
  data() {
    return {
      maxHeight: 0,
      yearList: [],
      headerList: [],
      activityRegs3:[],
      Population:[],
      hearderTitle: "统计时期:2022",
      yearColumn1: "年",
      yearColumn2: "年发明专利有效量（件）",
      yearColumn3: "年人口（万人）",
      // 遮罩层
      loading: false,
      // 选中数组
      ids: [],
      appDate:[],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专利有效-万人发明拥有量统计表格数据
      popuYearList: ['2001','2002'],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      opensb: true,
      regionOptions: {},
      ysDistrictCounty: [],
      Population: [],
      regionOptions: [],
      appDate1: ['2020-12','2021-12'],
      appDate2: ['2021-12','2022-12'],
      cpData: "act",
      cpContentArr: ["1", "2"],
      // 查询参数
      queryParams: {
        cpData: "act",
        province:"53",
        appliCity:null,
        appliCounty:null,
        cpContentArr: ["1", "2"],
        cpContents: null,
        pageNum: 1,
        pageSize: 10,
        patentType: null,
        cityCode: null,
        cityName: null,
        year: "2022",
        month: "12",
        higherSchool: null,
        researchInstitute: null,
        status: null,
        beginDate1:'202012',
        endDate1:'202112',
        beginDate2:'202112',
        endDate2:'202212',
      },
      // 表单参数
      form: {},
      activityRegs: [],
      activityRegs2: ['2022-01','2022-12'],
      activityRegs1: ['2021-01','2021-12'],
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.getHeader();
    this.getList();
    this.$nextTick(() => {
      this.maxHeight = window.innerHeight - 200; //300是页面中除了表格外其他组件的高度
    });
    this.getRegion()
  },
  methods: {
    /** 获取省市列表 */
    getRegion() {
      let params = {};
      getRegionList(params).then((response) => {
        this.regionOptions = response.data;
      });
    },
    appDateInput1(e) {
      console.log(e,'appDateInput1');
      this.$nextTick(() => {
        if (e == null) {
          this.queryParams.beginDate1 = null;
          this.queryParams.endDate1 = null;
        } else {
          console.log(this.activityRegs1);
          this.$set(this, "activityRegs1", [e[0], e[1]]);
          this.queryParams.beginDate1 = this.activityRegs1[0].replaceAll("-", "");
          this.queryParams.endDate1 = this.activityRegs1[1].replaceAll("-", "");
        }
      });
    },

    appDateInput2(e) {
      console.log(e,'appDateInput2');
      this.$nextTick(() => {
        if (e == null) {
          this.queryParams.beginDate2 = null;
          this.queryParams.endDate2 = null;
        } else {
          console.log(this.activityRegs2);
          this.$set(this, "activityRegs2", [e[0], e[1]]);
          this.queryParams.beginDate2 = this.activityRegs2[0].replaceAll(
            "-",
            ""
          );
          this.queryParams.endDate2 = this.activityRegs2[1].replaceAll("-", "");
        }
      });
    },
    /** 获取动态表头 */
    getHeader() {
      let head = "统计时期";
      this.hearderTitle = head;
    },
    search(q) {
      console.log(q);
      if (q == null || q == "" || q == "null"|| q == "all") {
        this.opensb = true;
        //this.queryParams.appliCounty = null;
        this.queryParams.appliCounty='null';
      } else {
        this.opensb = false;
        this.queryParams.appliCounty = "null";
        this.regionOptions.forEach((item) => {
          if (q == item.cityName) {
            this.ysDistrictCounty = item.areaList;
            this.opensb = false;
          }
        });
      }
    },

    refreshHeader() {
      this.cpData = this.queryParams.cpData;
      this.cpContentArr = this.queryParams.cpContentArr;
    },

    /** 查询专利有效-万人发明拥有量统计列表 */
    getList() {
      this.loading = true;
      this.refreshHeader();

      let cpData2 = this.cpData;
      let cpContentArr2 = this.cpContentArr;

      let cpContents = "";
      if (cpContentArr2.length > 0) {
        for (let i = 0; i < cpContentArr2.length; i++) {
          if (i > 0) {
            cpContents = cpContents + ",";
          }
          cpContents = cpContents + cpContentArr2[i];
        }
      }
      this.queryParams.cpContents = cpContents;

      listReportGrowth(this.queryParams).then(response=>{
       // this.popuYearList =  res.data.years
       // this.Population = res.data.list
        this.loading = false;
        let temp = [];
        response.data.forEach((item) => {
          let r1 = {};
          r1.areaName = item.areaName;
          r1 = { ...r1, ...item.item1 };
          let r2 = {};
          r2.areaName = "";
          r2 = { ...r2, ...item.item2 };
          let r3 = {};
          r3 = { ...item.growth };
          r3['regTotalCnt']=r3['regGrowth'];
          r3['aplTotalCnt']=r3['aplGrowth'];
          r3['actTotalCnt']=r3['actGrowth'];
          temp.push(r1);
          temp.push(r2);
          temp.push(r3);
        });
        this.Population = temp;


      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        patentType: null,
        cityCode: null,
        cityName: null,
        year: null,
        month: null,
        higherSchool: null,
        researchInstitute: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      if (this.queryParams.month) {
        if (this.queryParams.year) {
          this.getHeader();
          this.queryParams.pageNum = 1;
          this.getList();
        } else {
          this.$message("请选择年份");
        }
      } else {
        this.getHeader();
        this.queryParams.pageNum = 1;
        this.getList();
      }
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专利有效-万人发明拥有量统计";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getRzlInventStatisticsInfo(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专利有效-万人发明拥有量统计";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateRzlInventStatisticsInfo(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRzlInventStatisticsInfo(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm(
          '是否确认删除专利有效-万人发明拥有量统计编号为"' + ids + '"的数据项？'
        )
        .then(function () {
          return delRzlInventStatisticsInfo(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "trade/cTrademark/exportReportGrowth",
        {
          ...this.queryParams,
        },
        `rzlInventStatisticsInfo_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
